config/routes.rb
Rails.application.routes.draw do
  get 'todos/create'
  resources :lists do
    resources :todos do
      member do
        get 'flip_status'
      end
    end
  end
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/list.rb
class List < ApplicationRecord
  has_many :todos, dependent: :destroy
  validates :name, presence: true, uniqueness: true
end

app/models/todo.rb
class Todo < ApplicationRecord
  belongs_to :list
  validates :description, presence: true
  validates :description, uniqueness: { scope: :list }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/lists_controller.rb
class ListsController < ApplicationController
  def index
    @lists = List.all
    @list = List.new
  end

  def show
    @list = List.find(params[:id])
    @todo = Todo.new
  end

  def create
    @list = List.new(params.require(:list).permit(:name))
    if @list.save
      redirect_to lists_path
    else
      @lists = List.all
      render :index
    end
  end

  def destroy
    
  end
end

app/controllers/todos_controller.rb
class TodosController < ApplicationController
  before_action :set_list

  def create
    @todo = Todo.new(params.require(:todo).permit(:description))
    @todo.list_id = @list.id
    if @todo.save
      redirect_to list_path(@list)
    else
      redirect_to list_path(@list), notice: @todo.errors.full_messages.to_sentence
    end
  end

  def flip_status
    @todo = Todo.find(params[:id])
    @todo.status = !@todo.status
    @todo.save
    redirect_to list_path(@list)
  end

  def destroy
    @todo = Todo.find(params[:id])
    @todo.destroy
    redirect_to list_path(@list)
  end

  private

  def set_list
    @list = List.find(params[:list_id])
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/list_helper.rb
module ListHelper
end

app/helpers/todos_helper.rb
module TodosHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Thymecode</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/lists/destroy.html.erb
<h1>List#destroy</h1>
<p>Find me in app/views/list/destroy.html.erb</p>

app/views/lists/index.html.erb
<h1>List#index</h1>
<table>
  <tr>
    <td>Name</td>
    <td>Action</td>
  </tr>
<% @lists.each do |list| %>
  <tr>
    <td><%= list.name %></td>
    <td> <%= link_to 'Show', list %> </td>
  </tr>
<% end %>
</table>

<h1>New list</h1>
<%= form_with model: @list, local: true do |f| %>
  <% if @list.errors.any? %>
    <%= @list.errors.full_messages.to_sentence %>
  <% end %>
  <%= f.text_field :name %>
  <%= f.submit 'save' %>
<% end %>

app/views/lists/show.html.erb
<h1>List#show</h1>
<p><%= @list.name %></p>
<h1>Todos</h1>
<table>
  <tr>
    <td>Description</td>
    <td>Status</td>
    <td>Update</td>
    <td>Action</td>
  </tr>
  <% @list.todos.each do |todo| %>
    <tr>
      <td><%= todo.description %></td>
      <td>
        <%= todo.status ? 'Completed' : 'Not yet' %>
      </td>
      <td>
        <%= link_to 'Update status', flip_status_list_todo_path(list_id: @list.id, id: todo.id) %>
      </td>
      <td>
        <%= link_to 'Delete', [@list, todo], method: :delete %>
      </td>
    </tr>
  <% end %>
</table>


<%= form_with model: [@list, @todo], local: true do |f| %>
  <% flash.each do |key, value| %>
    <%= content_tag :div, value, class: "flash #{key}" %>
  <% end %>
  <%= f.text_field :description %>
  <%= f.submit 'save' %>
<% end %>

app/views/todos/create.html.erb
<h1>Todos#create</h1>
<p>Find me in app/views/todos/create.html.erb</p>